﻿Public Class Form1
    Public nachrichtenListe As New Stack(Of nachricht)
    Public benutzer
    Public room
    Public roomAdmin = False
    Public roomCreated = False
    Public connection As New TCP
    Public roundCount
    Public currentRound
    Public currentWord
    Public currentDrawerName As String
    Public currentDrawer As Boolean
    Public betweenRounds As Boolean
    Public drawPen As New Pen(Color.Black, 6)
    Dim Message
    Public feld As String()
    Public scoreboard As New Dictionary(Of String, Integer)
    Dim tt As New ToolTip
    Public drawForm As New drawForm
    Public startForm As New startForm
    Public scoreboardForm As New scoreboardForm
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        colorButton_Click(Button3, New EventArgs)
        receiver.WorkerSupportsCancellation = True
        receiver.RunWorkerAsync()
        Visible = False
        If Not roomCreated Then
            startForm.startButton.Enabled = False
        Else
            startForm.Controls.Add(New selectionBox(5, 0, 9, New Point(505, 467)))
        End If

        ' roundCount = startForm.anzahlRundenComboBox.SelectedItem
        tt.SetToolTip(startForm.roomNameLabel2, "Klick zum kopieren")
        switchPanel(startForm)
        'temp
        'Visible = True
        'drawBox.Dock = DockStyle.Fill
        'draw = drawBox.CreateGraphics
        'draw.Clear(Color.White)
        'welcomePanel.Visible = False
        ''
    End Sub




    Private Sub send_Click(sender As Object, e As EventArgs) Handles send.Click
        TextBox1.Focus()
        If TextBox1.Text = "" Then
            Return
        End If
        'nachrichtenListe.Push(New nachricht(TextBox1.Text, benutzer))
        '("message", {sender, messagetext})
        connection.send("message", {benutzer, TextBox1.Text})
        TextBox1.Clear()
    End Sub

    'Drawing



    Private Sub TextBox1_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TextBox1.KeyPress
        If e.KeyChar = Chr(13) Then
            e.Handled = True
            send_Click(New Object, New EventArgs)
        End If
    End Sub

    Private Sub colorButton_Click(sender As Object, e As EventArgs) Handles Button1.Click, Button2.Click, Button3.Click, Button4.Click, Button5.Click, Button6.Click, Button7.Click, Button8.Click, Button9.Click, Button10.Click, Button11.Click, Button12.Click, Button13.Click, Button14.Click, Button15.Click, Button16.Click, Button17.Click, Button18.Click, eraseButton.Click
        Try
            For Each item As Button In colorPanel.Controls.OfType(Of Button)
                item.FlatAppearance.BorderSize = 0
            Next
        Catch ex As Exception
        End Try
        sender.FlatAppearance.BorderSize = 1
        sender.FlatAppearance.BorderColor = Color.Red
        'solutionLabel.Text = sender.backcolor.ToString
        If sender Is eraseButton Then
            drawPen.Color = drawForm.drawBox.BackColor
            drawPen.Width = penSizeTrackBar.Value * 2 * 2
        Else
            drawPen.Color = sender.backcolor
            drawPen.Width = penSizeTrackBar.Value * 2
        End If

    End Sub

    Private Sub picResetButton_Click(sender As Object, e As EventArgs) Handles picResetButton.Click
        connection.send("clearDraw", {})

    End Sub

    Private Sub penSizeTrackBar_Scroll(sender As Object, e As EventArgs) Handles penSizeTrackBar.Scroll
        drawPen.Width = penSizeTrackBar.Value * 2
    End Sub

    Public Sub playerLabel_Click(sender As Object, e As EventArgs) Handles playerLabel.MouseClick, playerPanel.MouseClick
        If playerPanel.Height > 40 Then
            playerPanel.Height = 40
        Else
            playerPanel.Height = Methods.pLabel.Location.Y + Methods.pLabel.Height + 10
            'Dim p As New Point(20, 0)
            'For Each item As Label In playerPanel.Controls.OfType(Of Label)
            '    If item.Location.Y > p.Y Then
            '        p = item.Location
            '    End If
            'Next
            'playerPanel.Height = p.Y + 34
        End If
    End Sub


    Public Sub receiver_DoWork(sender As Object, e As System.ComponentModel.DoWorkEventArgs) Handles receiver.DoWork
        Try
            Message = connection.Reader.ReadLine()
            If Message = Nothing Then
                Message = ""
            End If
        Catch n As NullReferenceException
        Catch io As IO.IOException
            MsgBox("Die Verbindung zum Server wurde verloren!" & vbCrLf & "Programm wird geschlossen...", MsgBoxStyle.OkOnly, "Beende" & vbCrLf & io.ToString)
            Application.Exit()
        Catch ex As Exception
            errorLabel.Text = ex.ToString
        End Try
    End Sub
    Private Sub receiver_RunWorkerCompleted(sender As Object, e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles receiver.RunWorkerCompleted
        'feld 0 token, 1 benutzertoken, 2 methode, 3 daten

        feld = Message.split("#")
        If feld.Length > 1 Then
            Select Case feld(0)
                Case "drawLineOut"
                    drawForm.drawLineOut()
                Case "reloadPlayers"
                    reloadPlayers()
                Case "roomCreated"
                    Methods.roomCreated()
                Case "roomJoined"
                    roomJoined()
                Case "startDraw"
                    Methods.startDraw()
                Case "time"
                    Methods.time()
                Case "roundOver"
                    Methods.roundOver()
                Case "messageOut"
                    Methods.messageOut()
                Case "endGame"
                    Methods.endGame()
                Case "clearDraw"
                    drawForm.clearDraw()
                Case "hint"
                    Methods.hint()
                    'Case "roundOver"
                    '    Methods.roundOver()

                Case Else
                    errorLabel.Text = "Keine Methode gefunden!" + Message
            End Select
        End If
        'Methoden die empfangene Daten verarbeiten
        'token|benutzertoken|methodenname|daten~daten

        'kontaktListe(aktuellerKontaktIndex).nachrichtenListe.Add(New Nachricht(feld(1), True))
        feld = Nothing
        Message = ""
        receiver.RunWorkerAsync()
    End Sub




    Private Sub errorInfoLabel_Click(sender As Object, e As EventArgs) Handles errorLabel.Click, infoLabel.Click
        MsgBox(sender.text)
    End Sub

    Public Sub showInfo(msg As String)
        infoTimer.Tag = 0
        infoLabel.Text = msg
        infoTimer.Start()
    End Sub

    Public Sub showError(msg As String)
        errorTimer.Tag = 0
        errorLabel.Text = msg
        errorTimer.Start()
    End Sub
    Private Sub infoTimer_Tick(sender As Object, e As EventArgs) Handles infoTimer.Tick
        infoTimer.Tag += 1

        If infoTimer.Tag >= 3 Then
            infoLabel.Text = ""
            infoTimer.Stop()
        End If
    End Sub

    Private Sub errorTimer_Tick(sender As Object, e As EventArgs) Handles errorTimer.Tick
        errorTimer.Tag += 1
        If errorTimer.Tag >= 3 Then
            errorLabel.Text = ""
            errorTimer.Stop()
        End If
    End Sub



    Public Sub switchPanel(panel As Form)
        gamePanel.Controls.Clear()
        panel.TopLevel = False
        gamePanel.Controls.Add(panel)
        panel.Location = New Point(0, 0)
        panel.Show()
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        Application.Exit()
    End Sub


End Class
