﻿Module Methods
    Public WithEvents pLabel As New Label
    Public WithEvents sLabel As New Label

    Public Sub roomCreated()
        Form1.benutzer = LoginForm.usernameTextBox.Text
        LoginForm.Close()
        Form1.Visible = True
        With Form1
            Dim data = .feld(2).Split("~")
            .room = data(0)
            .roomNameLabel.Text = "Raum: " & data(0)
            .startForm.roomNameLabel2.Text = data(0)
        End With
    End Sub
    Public Sub roomJoined()
        With Form1
            .benutzer = LoginForm.usernameTextBox.Text
            Dim data = .feld(2).Split("~")
            If data(0) Then
                LoginForm.Close()
                .room = data(1)
                .roomNameLabel.Text = "Raum: " & data(1)
                .startForm.roomNameLabel2.Text = data(1)
                .Visible = True
                .startForm.settingsPanel.Visible = False
            Else
                .Close()
                MsgBox("Ungültiger Raum!")
            End If

        End With

    End Sub

    Public Sub startDraw()
        With Form1
            .switchPanel(drawForm)
            Dim data = .feld(2).Split("~")
            .currentDrawerName = data(0)
            If .currentDrawerName = .benutzer Then
                .drawForm.drawBox.Enabled = True
                .picResetButton.Enabled = True
                .currentDrawer = True
            Else
                .drawForm.drawBox.Enabled = False
                .picResetButton.Enabled = False
                .currentDrawer = False
            End If
            .drawerLabel.Text = "Es mahlt: " & .currentDrawerName
            .currentRound = data(1)
            .roundCount = data(2)
            .roundLabel.Text = "Runde: " & .currentRound & "/" & .roundCount
            '.drawForm.draw = .drawForm.drawBox.CreateGraphics
            '.drawForm.draw.Clear(Color.White)
            .betweenRounds = False
            setSolutionLabel(data(3))
            .infoLabel.Text = ""
        End With
    End Sub

    Public Sub setSolutionLabel(word As String)
        Dim wordLength = 0
        With Form1
            .currentWord = word
            wordLength = word.Length
            For i = word.Length - 1 To 1 Step -1
                word = word.Insert(i, " ")
            Next


            If .currentDrawerName = .benutzer Then
                .solutionLabel.Text = word
            Else
                Dim tempWord = ""
                For i = 0 To wordLength - 1
                    tempWord &= "_ "
                Next
                .solutionLabel.Text = tempWord
            End If
        End With
    End Sub

    ' messaging




    Public Sub time()
        Dim data = Form1.feld(2).Split("~")
        If Form1.betweenRounds Then
            Form1.timeLabel.Text = "Nächste Runde in: " & data(0)
        Else
            Form1.timeLabel.Text = data(0)
        End If

    End Sub

    Public Sub roundOver()
        With Form1
            Dim data = .feld(2).Split("~")
            .picResetButton.Enabled = False
            .drawForm.drawTimer.Stop()
            .infoLabel.Text = "Runde vorbei! Der nächste muss mahlen!"
            .betweenRounds = True
            .switchPanel(scoreboardForm)

        End With
    End Sub

    Public Sub endGame()
        With Form1
            Dim data = .feld(2).Split("~")
            .switchPanel(startForm)
            If .roomAdmin Then
                .startForm.settingsPanel.Visible = True
                .startForm.startButton.Enabled = True
            Else
                .startForm.settingsPanel.Visible = False
                .startForm.startButton.Enabled = False
            End If

        End With

    End Sub


    Public Sub reloadPlayers()
        With Form1
            '.showInfo("Spieler werden neu geladen!")
            Dim data = .feld(2).Split("~")
            .scoreboard.Clear()
            For Each item In data
                Dim data2 = item.Split("*")
                .scoreboard.Add(data2(0), data2(1))
            Next
            ' playerLabelList.Clear()
            ' scoreboardLabelList.Clear()
            For Each item As Label In .playerPanel.Controls.OfType(Of Label)
                If Not item.Name = "playerLabel" Then
                    item.Text = ""
                    'item.Dispose()
                End If
            Next

            Dim o = ""
            For Each item In .scoreboard.Keys
                o &= item.ToString & vbCrLf
            Next
            Dim u = ""
            For Each item In .scoreboard.Values
                u &= item.ToString & vbCrLf
            Next

            pLabel.Location = New Point(20, 50)
            pLabel.Size = New Size(200, 30)
            pLabel.AutoSize = True
            pLabel.FlatStyle = FlatStyle.Flat
            pLabel.Text = o
            pLabel.Font = New Font("Microsoft Sans Serif", 18.0!, FontStyle.Regular, GraphicsUnit.Point, CType(0, Byte))


            sLabel.Location = New Point(pLabel.Location.X + 250, 50)
            sLabel.Size = New Size(30, 30)
            sLabel.AutoSize = True
            sLabel.FlatStyle = FlatStyle.Flat
            sLabel.Text = u
            sLabel.Font = New Font("Microsoft Sans Serif", 18.0!, FontStyle.Regular, GraphicsUnit.Point, CType(0, Byte))

            .playerPanel.Controls.Add(pLabel)
            .playerPanel.Controls.Add(sLabel)

            scoreboardForm.setLabels()

            If .playerPanel.Height > 40 Then .playerPanel.Height = pLabel.Location.Y + pLabel.Height + 10

        End With
    End Sub

    Public Sub hint()
        With Form1
            Dim data = .feld(2).Split("~")
            .solutionLabel.Text = .solutionLabel.Text.Remove(data(0) * 2, 1)
            .solutionLabel.Text = .solutionLabel.Text.Insert(data(0) * 2, data(1))
        End With
    End Sub

    Public Sub messageOut()
        With Form1
            Dim data = .feld(2).Split("~")
            .nachrichtenListe.Push(New nachricht(data(1), data(0)))
        End With
    End Sub

End Module
